; =================================================================
; Object
; 
; Player
; =================================================================

; =================================================================
; ------------------------------------------------
; Variables
; ------------------------------------------------

varPlyr_VRAM		equ	($6000+$570)
var_ScrHor		equ	320

; =================================================================
; ------------------------------------------------
; RAM
; ------------------------------------------------

		rsset obj_ram
plyr_lvltrgt	rs.w	1
plyr_busy	rs.b	1

; =================================================================
; ------------------------------------------------
; Code start
; ------------------------------------------------

Obj_Player:
 		moveq	#0,d0
 		move.b	obj_index(a6),d0
 		add.w	d0,d0
 		move.w	@Index(pc,d0.w),d1
 		jsr	@Index(pc,d1.w)

 		;Render
   		move.l	#(varPlyr_VRAM<<16),d0
 		move.l	#ani_player,d1
		bsr	Object_Animate
		
   		move.b	obj_frame(a6),d0
		move.l	#map_player,d1
		bsr	Object_Show
 		
   		move.b	obj_frame(a6),d0
		move.l	#dplc_player,d1
		move.l	#art_player,d2
		bra	Object_DPLC
		
; ------------------------------------------------

@Index:
		dc.w	ObjPlyr_Init-@Index
		dc.w	ObjPlyr_Main-@Index
		even
		
; =================================================================
; ------------------------------------------------
; Index $00: Init
; ------------------------------------------------

ObjPlyr_Init:
		add.b	#1,obj_index(a6)
		move.l	#$01010400,obj_size(a6)
		
; =================================================================
; ------------------------------------------------
; Index $01: Main
; ------------------------------------------------

ObjPlyr_Main:
		btst	#bitJoyA,(RAM_Joypads+OnPress)
		beq.s	@NotDbg
		clr.l	obj_x(a6)
		clr.l	obj_y(a6)
		clr.l	obj_x_spd(a6)
		clr.l	obj_y_spd(a6)
		lea	(RAM_LevelBuffer),a5
		clr.w	lvl_x(a5)
		clr.w	lvl_y(a5)
		movem.l	a6,-(sp)
		bsr	Level_Draw
		movem.l	(sp)+,a6
@NotDbg:
		
		btst	#bitJoyB,(RAM_Joypads+OnHold)
		beq.s	@NotWnd
		bra	@DebugPlayer
@NotWnd:

; ----------------------------------

		btst	#bitobj_air,obj_status(a6)
		beq.s	@idleanim
		tst.l	obj_y_spd(a6)
		beq.s	@idleanim
		bmi.s	@idleanim
		move.b	#3,obj_anim_id(a6)
@idleanim:

; ----------------------------------
; Player physics
; ----------------------------------

@PlyrPhysics:
		lea	(RAM_LevelBuffer),a5
		move.l	obj_x_spd(a6),d6
		move.l	obj_y_spd(a6),d7

; ***************
; X Speed stuff
; ***************

		bsr	@Player_Friction
		bsr	@Player_Walk
		add.l	d6,obj_x(a6)			;X + X Speed
 		bsr	@Collision_Wall
		bsr	@ObjCol_Wall
		
; ***************
; Y Speed stuff
; ***************

		bsr	@Player_Jump
		add.l	d7,obj_y(a6)			;Y + Y Speed
		tst.l	d7
		bmi.s	@NoCol2
		bsr	@Collision_Floor
		bsr	@ObjCol_Floor
@NoCol2:
		tst.l	d7
		bpl.s	@Nope_Up
  		bsr	@Collision_Ceiling
		bsr	@ObjCol_Ceiling
@Nope_Up:

		
; ***************
; Save them
; ***************

		move.l	d6,obj_x_spd(a6)
		move.l	d7,obj_y_spd(a6)
		
; ------------------------
; Animation ID
; ------------------------

		btst	#bitobj_air,obj_status(a6)
		bne.s	@walking
		move.b	#1,obj_anim_id(a6)
		tst.l	d6
		bne.s	@walking
		tst.l	obj_x_spd(a6)
		bne.s	@walking
		clr.b	obj_anim_id(a6)
@walking:
		bra	@plyr_camera
	
; ----------------------------------

@DebugPlayer:
		btst	#bitJoyRight,(RAM_Joypads+OnHold)
		beq.s	@DNotRight
		add.l	#$50000,obj_x(a6)
		bclr	#bitobj_dir,obj_status(a6)
@DNotRight:
		btst	#bitJoyLeft,(RAM_Joypads+OnHold)
		beq.s	@DNotLeft
		sub.l	#$50000,obj_x(a6)
		bset	#bitobj_dir,obj_status(a6)
@DNotLeft:
		btst	#bitJoyDown,(RAM_Joypads+OnHold)
		beq.s	@DNotDown
		add.l	#$50000,obj_y(a6)
@DNotDown:
		btst	#bitJoyUp,(RAM_Joypads+OnHold)
		beq.s	@DNotUp
		sub.l	#$50000,obj_y(a6)
@DNotUp:
		move.l	#1,obj_x_spd(a6)		;Temporal
		move.l	#1,obj_y_spd(a6)
 		bra	@plyr_camera
 		
; =================================================================
; ------------------------------------------------
; Subs
; ------------------------------------------------

; **********************************
; Player Walk
; **********************************

@Player_Walk:
		btst	#bitJoyRight,(RAM_Joypads+OnHold)
		beq.s	@NotRight
		moveq	#0,d0
		move.w	(RAM_LevelBuffer+lvl_x_size),d0
		lsl.w	#4,d0
		move.w	obj_x(a6),d1
		cmp.w	d0,d1
		bgt.s	@NotRight

		add.l	#$5000,d6
		cmp.l	#$30000,d6
		blt.s	@NotMuchRight
		move.l	#$30000,d6
@NotMuchRight:
		bclr	#bitobj_dir,obj_status(a6)

@NotRight:
		btst	#bitJoyLeft,(RAM_Joypads+OnHold)
		beq.s	@NotLeft
		tst.l	obj_x(a6)
		beq.s	@NotLeft
		bmi.s	@NotLeft
		
		sub.l	#$5000,d6
		cmp.l	#-$30000,d6
		bgt.s	@NotMuchLeft
		move.l	#-$30000,d6
@NotMuchLeft:
		bset	#bitobj_dir,obj_status(a6)
@NotLeft:		
		rts
		
; **********************************
; Player Friction
; **********************************

@Player_Friction:
		move.l	#$2000,d4			;Friction
		tst.l	d6
		beq.s	@FineSpeed
		btst	#bitobj_dir,obj_status(a6)
		bne.s	@Left
		sub.l	d4,d6
		bpl.s	@FineSpeed
		clr.l	d6
		rts
@Left:
		add.l	d4,d6
		bmi.s	@FineSpeed
		
@ignoreR:
		clr.l	d6
@FineSpeed:	
		rts

; **********************************
; Player jump
; **********************************

@Player_Jump:
		btst	#bitJoyC,(RAM_Joypads+OnPress)
		beq.s	@NotJump
		
		btst	#bitobj_col,obj_col(a6)
		bne.s	@CanJump
 		bsr	object_FindPrz_Floor
 		move.l	d0,d2
    		bsr	object_FindPrz_FloorSides
     		tst.b	d0
  		bne.s	@CanJump
    		tst.b	d1
   		bne.s	@CanJump
    		tst.b	d2
   		bne.s	@CanJump
   		
 		bsr	object_FindCol_Floor
 		move.l	d0,d2
    		bsr	object_FindCol_FloorSides
     		tst.b	d0
  		bne.s	@CanJump
    		tst.b	d1
   		bne.s	@CanJump
    		tst.b	d2
   		bne.s	@CanJump
		
 		bra.s	@NotJump

@CanJump:
		bset	#bitobj_air,obj_status(a6)
		move.b	#2,obj_anim_id(a6)
   		
		move.l	#sfx_CharJump,d0
		moveq	#1,d1
		bsr	SMEG_LoadSfx
		
   		move.l	#-$60000,d7
   		rts
@NotJump:

; Falling
; 		btst	#bitobj_col,obj_col(a6)
; 		beq.s	@no_fall
; 		clr.l	d7
; 		rts
; @no_fall:

		add.l	#$4000,d7
		cmp.l	#$100000,d7
		blt.s	@low_fall
		move.l	#$100000,d7
@low_fall:
		rts
		
; **********************************
; Object to Level layout collision
; **********************************

; ----------------------------------
; floor collision
; ----------------------------------

@Collision_Floor:
		bsr	object_FindPrz_Floor
		move.l	d0,d2
 		bsr 	object_FindPrz_FloorSides
		bsr	@prizes_floor

		bsr	object_FindCol_Floor
		tst.b	d0
		bne	@found_center
 		bsr 	object_FindCol_FloorSides
 		tst.b	d0
 		bne	@found_sides
 		tst.b	d1
 		bne	@found_sides
		rts
		
; ----------------------------------

@found_center:
		cmp.b	#1,d0
		beq	@floorsolid

   		tst.l	d7
   		bmi.s	@NoCol
   		
   		move.l	obj_y(a6),d1
   		move.l	d1,d3
  		lea	(col_SlopeData),a3
  		and.w	#$FF,d0
  		move.w	d0,d1
  		lsl.w	#4,d1
  		adda	d1,a3
 		move.l	obj_x(a6),d0
 		swap	d0
 		and.w	#$F,d0
 		move.b	(a3,d0.w),d0
    		and.w	#$F,d0
    		and.l	#$FFF00000,d1
  		swap	d0
  		and.l	#$FFFF0000,d0
 		add.l	d0,d1
 		
		btst	#bitobj_air,obj_status(a6)
		beq.s	@dontchk
  		add.l	d7,d3
  		cmp.l	d1,d3
  		blt.s	@NoCol
@dontchk:
  		move.l	d1,obj_y(a6)

   		bclr	#bitobj_air,obj_status(a6)
 		clr.l	d7
     		tst.l	d6
     		beq.s	@NoCol
    		move.l	#$10000,d7
@NoCol:
		rts
		
; ----------------------------------

@found_sides:
		cmp.b	#1,d0
		beq.s	@floorsolid
		cmp.b	#1,d1
		beq.s	@floorsolid
		rts

; ----------------------------------
; d0 - LEFT
; d1 - RIGHT
; d2 - CENTER
; ----------------------------------

@prizes_floor:
		tst.b	d0
		beq.s	@prz_no_l
		bsr	@check_prz_id
@prz_no_l:
		move.l	d1,d0
		tst.b	d0
		beq.s	@prz_no_r
		bsr	@check_prz_id
@prz_no_r:
		move.l	d2,d0
		tst.b	d0
		beq.s	@prz_no_c
		bsr	@check_prz_id
@prz_no_c:
		rts
		
; ----------------------------------

@check_prz_id:
;       		bsr	level_CheckPrize
;        		bne	@floorsolid
;        		rts

; ----------------------------------

@floorsolid:
		bclr	#bitobj_air,obj_status(a6)
		and.l	#$FFF00000,obj_y(a6)
		clr.l	d7
		rts
		
; **********************************
; ceiling collision
; **********************************

@Collision_Ceiling:
		bsr	object_FindPrz_Ceiling
 		move.l	d0,d2
 		bsr 	object_FindPrz_CeilingSides
		bsr	@prizes_ceiling
   		
		bsr	object_FindCol_Ceiling
		tst.b	d0
		bne	@ceilingsolid
   		bsr 	object_FindCol_CeilingSides
   		tst.b	d0
   		bne	@ceilingsolid
   		tst.b	d1
   		bne	@ceilingsolid
		rts

; ----------------------------------
; d0 - LEFT
; d1 - RIGHT
; d2 - CENTER
; ----------------------------------

@prizes_ceiling:
		move.l	d0,d3
		btst	#bitobj_dir,obj_status(a6)
		beq.s	@itsleft
		exg.l	d1,d3
@itsleft:

   		move.l	d2,d0
   		tst.b	d0
   		beq.s	@przc_no_c
  		bsr	@check_przc_id
 		tst.w	d4
 		bne	@ceilingsolid
@przc_no_c:

		move.l	d1,d0
		tst.b	d0
		beq.s	@przc_no_r
		bsr	@check_przc_id
		tst.w	d4
		bne	@ceilingsolid
@przc_no_r:
 		move.l	d3,d0
 		tst.b	d0
 		beq.s	@przc_no_l
 		bsr	@check_przc_id
		tst.w	d4
		bne	@ceilingsolid
@przc_no_l:
		rts
		
; ----------------------------------

@check_przc_id:
		moveq	#0,d5
		move.b	d0,d5
		lsl.w	#1,d5
		move.w	@block_list(pc,d5.w),d6
		tst.w	d6
		beq	@ceilingsolid
		jmp	@block_list(pc,d6.w)
		
; ----------------------------------

@block_list:
		dc.w	0
		dc.w	@breakblock-@block_list
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		dc.w	0
		
; ----------------------------------

@breakblock:
		lea	(RAM_LevelBuffer),a5
		lea	(RAM_LevelPrizes),a4
		move.l	d0,d4
		lsr.l	#8,d4
		and.l	#$FFF,d4
		mulu.w	lvl_x_size(a5),d4
		adda	d4,a4
		move.l	d0,d4
		swap	d4
		lsr.w	#4,d4
		and.l	#$FFF,d4
		adda	d4,a4
		clr.b	(a4)
		
 		move.l	d0,d4			;Postion | XXX?????
 		swap	d4			;????XXX?
 		lsr.w	#4,d4			;????0XXX
 		lsl.w	#2,d4
 		and.l	#$7F,d4
 		move.l	d0,d5			;???YYY??
  		and.l	#$F00,d5
   		or.w	d5,d4
 		move.l	#$40000003,d5
 		swap	d5
 		or.w	d4,d5
 		swap	d5 		
  		movea.l	lvl_layout(a5),a4	;Layout data
 		move.l	d0,d4
 		and.l	#$000FFF00,d4
 		lsr.l	#8,d4
 		and.l	#$FFF,d4
 		mulu.w	lvl_x_size(a5),d4
;  		lsl.w	#1,d4
 		adda	d4,a4	
  		move.l	d0,d4
 		and.l	#$FFF00000,d4
  		swap	d4
  		lsr.w	#4,d4
;    		lsl.w	#1,d4
   		adda 	d4,a4
    		moveq	#0,d4
   		move.b	(a4),d4
		movea.l	lvl_blocks(a5),a4	;Draw blocks
  		lsl.l	#3,d4
  		and.l	#$FFFF,d4
   		adda 	d4,a4
 		move.l	d5,($C00004).l
 		move.w	(a4),d4
 		swap	d4
 		move.w	4(a4),d4
 		move.l	d4,($C00000).l
 		add.l	#$800000,d5
 		move.l	d5,($C00004).l
 		move.w	2(a4),d4
 		swap	d4
 		move.w	6(a4),d4
 		move.l	d4,($C00000).l

  		move.l	d1,d4
		move.l	#sfx_PrizeToing,d0
 		moveq	#1,d1
 		bsr	SMEG_LoadSfx
  		move.l	d4,d1
		
  		moveq	#1,d4
  		rts

@ceilingsolid:
		bset	#bitobj_air,obj_status(a6)
		clr.l	d7
 		rts
		
; **********************************
; Wall collision
; **********************************

@Collision_Wall:
; 		bsr	object_FindPrz_Wall 
; 		move.l	d0,d2
		bsr	object_FindPrz_WallSides
		bsr	@prizes_wall
 		
 		bsr	object_FindCol_Wall
 		tst.b	d0
 		bne	@wall_center
		bsr	object_FindCol_WallSides
		tst.b	d0
 		bne	@wall_right
		tst.b	d1
		bne	@wall_left
		rts
		
@wall_center:
		cmp.w	#1,d0
 		beq	@wallsolid_slope
		
   		move.l	obj_y(a6),d2
    		swap	d2
     		and.w	#$F,d2
     		bne.s	@NoCol_LR
     		
    		lea	(col_SlopeData),a3
    		and.l	#$FF,d0
    		move.w	d0,d3
    		lsl.w	#4,d3
    		adda	d3,a3
    		move.l	obj_x(a6),d0
    		swap	d0
    		and.w	#$F,d0
    		move.b	(a3,d0.w),d0
    		and.w	#$F,d0
    		and.l	#$FFF00000,obj_y(a6)
  		swap	d0
  		and.l	#$FFFF0000,d0

 		sub.l	d0,obj_y(a6)
  		tst.l	d6
  		beq.s	@ClrYSpd
  		tst.l	d7
  		bmi.s	@NoCol_LR
@ClrYSpd:
  		bclr	#bitobj_air,obj_status(a6)
           	clr.l	d7
@NoCol_LR:
		rts

; ----------------------------------
; d0 - RIGHT
; d1 - LEFT
; d2 - CENTER
; ----------------------------------

@prizes_wall:
		move.l	d0,d3

; 		btst	#bitobj_air,obj_status(a6)
; 		bne.s	@przw_no_c
;   		move.l	d2,d0
;   		tst.b	d0
;   		beq.s	@przw_no_c
;  		bsr	@check_przw_id
; @przw_no_c:

  		btst	#bitobj_dir,obj_status(a6)
   		beq.s	@przw_no_r 		
  		move.l	d1,d0
  		tst.b	d0
  		beq.s	@przw_no_l
  		bra	@check_przw_id

@przw_no_r:
 		btst	#bitobj_dir,obj_status(a6)
  		bne.s	@przw_no_r		
 		move.l	d3,d0
  		tst.b	d0
  		beq.s	@przw_no_l
  		bsr	@check_przw_id
@przw_no_l:
		rts
		
; ----------------------------------

@check_przw_id:
		bra.s	@wallsolid
		
; ----------------------------------

@wall_right:
		btst	#bitobj_dir,obj_status(a6)
		bne.s	@return_w
  		cmp.b	#2,d0
  		bge.s	@return_w
 		cmp.b	#1,d0
  		beq.s	@wallsolid
  		rts
  		
@wall_left:
		btst	#bitobj_dir,obj_status(a6)
		beq.s	@return_w
		move.w	obj_x(a6),d0
		moveq	#0,d2
		move.b	obj_size(a6),d2
		lsl.w	#3,d2
		sub.w	d2,d0
		bmi.s	@return_w
		
  		cmp.b	#2,d1
  		bge.s	@return_w
  		cmp.b	#1,d1
  		beq.s	@wallsolid
@return_w:
		rts
		
; @checkforslope:
; 		bsr	object_FindPrz_Floor
; 		cmp.b	#2,d0
; 		blt.s	@wallsolid
; 		bsr	object_FindPrz_FloorSides
; 		cmp.b	#2,d0
; 		blt.s	@wallsolid
; 		cmp.b	#2,d1
; 		blt.s	@wallsolid
; 		rts
		
@wallsolid:
		clr.l	d6
@wallsolid_slope:
      		and.l	#$FFF80000,obj_x(a6)
     		btst	#bitobj_dir,obj_status(a6)
      		beq.s	@Right
      		add.w	#8,obj_x(a6)
@Right:
      		and.l	#$FFF80000,obj_x(a6)
 		rts
 		
; ----------------------------------
; Object interact
; ----------------------------------

@ObjCol_Floor:
		bsr	@objtouch_floor
		bclr	#bitobj_col,obj_col(a6)
		
		btst	#bitobj_solid,obj_status(a4)
		beq.s	@nothin
		tst.b	d5
		beq.s	@nothin
		bset	#bitobj_col,obj_col(a6)
		
		and.l	#$FFF80000,obj_y(a6)
		moveq	#0,d1
		move.w	obj_y(a4),d0
		move.b	obj_size+2(a4),d1
		lsl.w	#3,d1
		sub.w	d1,d0
		and.w	#%111,d0
		or.w	d0,obj_y(a6)
		bclr	#bitobj_air,obj_status(a6)
		clr.l	d7
@nothin:
		rts

; ----------------------------------

@ObjCol_Ceiling:
		bsr	@objtouch_ceiling

		bclr	#bitobj_colu,obj_col(a6)
		btst	#bitobj_solid,obj_status(a4)
		beq.s	@nothin_c
		tst.b	d5
		beq.s	@nothin_c
		bset	#bitobj_colu,obj_col(a6)
		
;  		and.l	#$FFF80000,obj_y(a6)
; 		moveq	#0,d1
; 		move.w	obj_y(a4),d0
; 		move.b	obj_size+2(a4),d1
; 		lsl.w	#3,d1
; 		sub.w	d1,d0
; 		and.w	#%111,d0
; 		or.w	d0,obj_y(a6)
; 		bclr	#bitobj_air,obj_status(a6)
		clr.l	d7
@nothin_c:
		rts

; ----------------------------------

@ObjCol_Wall:
		bsr	@objtouch_wall_r
		bclr	#bitobj_colr,obj_col(a6)
		btst	#bitobj_solid,obj_status(a4)
 		beq.s	@notwall_r
 		
		tst.b	d5
		beq.s	@notwall_r
		
		bset	#bitobj_colr,obj_col(a6)
		moveq	#0,d1
		move.w	obj_x(a4),d0
		move.b	obj_size(a4),d1
		lsl.w	#3,d1
		sub.w	d1,d0
		sub.w	#8,d0
		tst.w	d0
		bpl.s	@neg_x
		clr.w	d0
@neg_x
		move.w	d0,obj_x(a6)
		clr.l	d6
		
@notwall_r:
		bsr	@objtouch_wall_l
		
		bclr	#bitobj_coll,obj_col(a6)
  		btst	#bitobj_solid,obj_status(a4)
  		beq.s	@notwall_l
		tst.b	d5
		beq.s	@notwall_l

		bset	#bitobj_coll,obj_col(a6)
		moveq	#0,d1
		move.w	obj_x(a4),d0
		move.b	obj_size+1(a4),d1
		lsl.w	#3,d1
		add.w	d1,d0
		add.w	#8,d0
		move.w	d0,obj_x(a6)
		clr.l	d6
 		
@notwall_l:

		rts

; ----------------------------------
; Search object
; 
; d5 - Collision
; a4 - Object code
; ----------------------------------

@objtouch_floor:
		moveq	#0,d5
		lea	(RAM_ObjBuffer+(sizeof_obj*8)),a4
		moveq	#max_objects-1,d4
@next_fl:
		tst.l	obj_code(a4)
		beq.s	@nothing_fl
		bsr	@flags_floor
		tst.l	d5
		beq.s	@nothing_fl
		rts
@nothing_fl:
		adda	#sizeof_obj,a4
		dbf	d4,@next_fl
		rts
		
; ----------------------------------

@objtouch_ceiling:
		moveq	#0,d5
		lea	(RAM_ObjBuffer+(sizeof_obj*8)),a4
		moveq	#max_objects-1,d4
@next_cei:
		tst.l	obj_code(a4)
		beq.s	@nothing_cei
		bsr	@flags_ceiling
		tst.l	d5
		beq.s	@nothing_cei
		rts
@nothing_cei:
		adda	#sizeof_obj,a4
		dbf	d4,@next_cei
		rts
		
; ----------------------------------

@objtouch_wall_l:
		moveq	#0,d5
		lea	(RAM_ObjBuffer+(sizeof_obj*8)),a4
		moveq	#max_objects-1,d4
@next_wall_l:
		tst.l	obj_code(a4)
		beq.s	@nothing_wall_l
		bsr	@flags_wall_l
		tst.l	d5
		beq.s	@nothing_wall_l
		rts
@nothing_wall_l:
		adda	#sizeof_obj,a4
		dbf	d4,@next_wall_l
		rts
		
; ----------------------------------

@objtouch_wall_r:
		moveq	#0,d5
		lea	(RAM_ObjBuffer+(sizeof_obj*8)),a4
		moveq	#max_objects-1,d4
@next_wall_r:
		tst.l	obj_code(a4)
		beq.s	@nothing_wall_r
		bsr	@flags_wall_r
		tst.l	d5
		beq.s	@nothing_wall_r
		rts
@nothing_wall_r:
		adda	#sizeof_obj,a4
		dbf	d4,@next_wall_r
		rts
		
; ----------------------------------

@flags_floor:
 		move.w	obj_y(a6),d0
 		moveq	#1,d3
		bra	@X_points

@flags_ceiling:
 		moveq	#0,d1
 		move.w	obj_y(a6),d0
 		sub.w	#1,d0
  		move.b	obj_size+2(a6),d1
  		lsl.w	#3,d1
  		sub.w	d1,d0
 		move.w	#1,d3
 		bra	@X_points

; ----------------------------------

@flags_wall_r:
		;Y CENTER
		moveq	#0,d2
		move.w	obj_y(a6),d0
		move.b	obj_size+2(a6),d2
		lsl.w	#3,d2
		sub.w	d2,d0
		add.w	#1,d0
		swap	d0
		move.w	obj_y(a6),d0
		sub.w	#1,d0
		
		moveq	#0,d2
		move.w	obj_y(a4),d1
		sub.w	#1,d1
		swap	d1
		move.w	obj_y(a4),d1
		move.b	obj_size+2(a4),d2
		lsl.w	#3,d2
		sub.w	d2,d1
		cmp.w	d1,d0
		blt.s	@NoWallR
		swap	d0
		swap	d1
		cmp.w	d1,d0
		bgt.s	@NoWallR
		
		;d1 - Object X
 		moveq	#0,d2
 		move.w	obj_x(a4),d1
 		move.b	obj_size+1(a4),d2
 		lsl.w	#3,d2
 		add.w	d2,d1
 		swap	d1
		move.w	obj_x(a4),d1
		move.b	obj_size(a4),d2
		lsl.w	#3,d2
		sub.w	d2,d1
		
		moveq	#1,d3
		move.w	obj_x(a6),d0
		move.b	obj_size+1(a6),d2
		lsl.w	#3,d2
		add.w	d2,d0
		cmp.w	d1,d0
		blt.s	@NoWallR
		swap	d1
		cmp.w	d1,d0
		bge.s	@NoWallR_S
		or.w	d3,d5	
@NoWallR_S:
		swap	d1
@NoWallR:
		rts
		
; ----------------------------------

@flags_wall_l:
		;Y CENTER
		moveq	#0,d2
		move.w	obj_y(a6),d0
		move.b	obj_size+2(a6),d2
		lsl.w	#3,d2
		sub.w	d2,d0
		add.w	#1,d0
		swap	d0
		move.w	obj_y(a6),d0
		sub.w	#1,d0
		
		moveq	#0,d2
		move.w	obj_y(a4),d1
		sub.w	#1,d1
		swap	d1
		move.w	obj_y(a4),d1
		move.b	obj_size+2(a4),d2
		lsl.w	#3,d2
		sub.w	d2,d1
		cmp.w	d1,d0
		blt.s	@NoWallL
		swap	d0
		swap	d1
		cmp.w	d1,d0
		bgt.s	@NoWallL
		
		;d1 - Object X
 		moveq	#0,d2
 		move.w	obj_x(a4),d1
 		move.b	obj_size+1(a4),d2
 		lsl.w	#3,d2
 		add.w	d2,d1
 		swap	d1
		move.w	obj_x(a4),d1
		move.b	obj_size(a4),d2
		lsl.w	#3,d2
		sub.w	d2,d1
		
		moveq	#1,d3
		move.w	obj_x(a6),d0
 		sub.w	#1,d0
		move.b	obj_size(a6),d2
		lsl.w	#3,d2
		sub.w	d2,d0
		cmp.w	d1,d0
		blt.s	@NoWallL
		swap	d1
		cmp.w	d1,d0
		bge.s	@NoWallL_S
		or.w	d3,d5	
@NoWallL_S:
		swap	d1
@NoWallL:
		rts


; 
; ; -----------------
; ; Sides
; ; -----------------
; 
; 		;Y CENTER
; 		moveq	#0,d2
; 		move.w	obj_y(a6),d0
; 		move.b	obj_size+2(a6),d2
; 		lsl.w	#3,d2
; 		sub.w	d2,d0
; 		add.w	#1,d0
; 		swap	d0
; 		move.w	obj_y(a6),d0
; 		sub.w	#1,d0
; 		
; 		moveq	#0,d2
; 		move.w	obj_y(a4),d1
; 		sub.w	#1,d1
; 		swap	d1
; 		move.w	obj_y(a4),d1
; 		move.b	obj_size+2(a4),d2
; 		lsl.w	#3,d2
; 		sub.w	d2,d1
; 		cmp.w	d1,d0
; 		blt.s	@No_Wall
; 		swap	d0
; 		swap	d1
; 		cmp.w	d1,d0
; 		bgt.s	@No_Wall
; 		
; 		;d1 - Object X
;  		moveq	#0,d2
;  		move.w	obj_x(a4),d1
;  		move.b	obj_size+1(a4),d2
;  		lsl.w	#3,d2
;  		add.w	d2,d1
;  		swap	d1
; 		move.w	obj_x(a4),d1
; 		move.b	obj_size(a4),d2
; 		lsl.w	#3,d2
; 		sub.w	d2,d1
; 		
; 		moveq	#1,d3
; 		move.w	obj_x(a6),d0
; 		move.b	obj_size+1(a6),d2
; 		lsl.w	#3,d2
; 		add.w	d2,d0
; 		cmp.w	d1,d0
; 		blt.s	@NoWallR
; 		swap	d1
; 		cmp.w	d1,d0
; 		bge.s	@NoWallR_S
; 		or.w	d3,d5	
; @NoWallR_S:
; 		swap	d1
; @NoWallR:
; 
; 		move.w	#$100,d3
; 		move.w	obj_x(a6),d0
;  		sub.w	#1,d0
; 		move.b	obj_size(a6),d2
; 		lsl.w	#3,d2
; 		sub.w	d2,d0
; 		cmp.w	d1,d0
; 		blt.s	@NoWallL
; 		swap	d1
; 		cmp.w	d1,d0
; 		bge.s	@NoWallL_S
; 		or.w	d3,d5	
; @NoWallL_S:
; 		swap	d1
; @NoWallL:
; 		
; @No_Wall:
; 
; ; -----------------
; ; FLOOR/CEILING
; ; -----------------		
; 
; 		swap	d5
; 		
; 		;BOTTOM
; 		move.w	obj_y(a6),d0
; 		moveq	#1,d3
; 		bsr	@X_points
; 		
; 		;TOP
; 		moveq	#0,d1
; 		move.w	obj_y(a6),d0
; 		sub.w	#1,d0
;  		move.b	obj_size+2(a6),d1
;  		lsl.w	#3,d1
;  		sub.w	d1,d0
; 		move.w	#$100,d3
; 		bsr	@X_points
; 		
; ; -----------------
; 
; 
; 		rts
; 		
; 		
; -----------------

@X_points:
		moveq	#0,d2
		move.w	obj_y(a4),d1
		swap	d1
		move.w	obj_y(a4),d1
		move.b	obj_size+2(a4),d2
		lsl.w	#3,d2
		sub.w	d2,d1
		cmp.w	d1,d0
		blt.s	@No_Floor
		swap	d1
		cmp.w	d1,d0
		bge.s	@No_Floor
		
; -----------------
; d1 - X sides
; RRRRLLLL
; -----------------

		moveq	#0,d2
		move.w	obj_x(a4),d1
 		move.b	obj_size+1(a4),d2
		lsl.w	#3,d2
		add.w	d2,d1
		swap	d1
		moveq	#0,d2
		move.w	obj_x(a4),d1
 		move.b	obj_size(a4),d2
		lsl.w	#3,d2
		sub.w	d2,d1
		
; -----------------
; ? -- ? -- X
; -----------------

		moveq	#0,d2
		move.w	obj_x(a6),d0
		sub.w	#1,d0
		move.b	obj_size+1(a6),d2
		lsl.w	#3,d2
		add.w	d2,d0
; 		moveq	#%001,d3
		
		cmp.w	d1,d0
		blt.s	@NoFloorR_L
		swap	d1
		cmp.w	d1,d0
		bgt.s	@NoFloorR_R
		or.w	d3,d5
@NoFloorR_R:
		swap	d1
@NoFloorR_L:

; -----------------
; ? -- X -- ?
; -----------------

		move.w	obj_x(a6),d0
		lsl.w	#1,d3
; 		moveq	#%010,d3
		
		cmp.w	d1,d0
		blt.s	@NoFloorC_L
		swap	d1
		cmp.w	d1,d0
		bgt.s	@NoFloorC_R
		or.w	d3,d5
@NoFloorC_R:
		swap	d1
@NoFloorC_L:

; -----------------
; X -- ? -- ?
; -----------------

		moveq	#0,d2
		move.w	obj_x(a6),d0
		add.w	#1,d0
		move.b	obj_size(a6),d2
		lsl.w	#3,d2
		sub.w	d2,d0
		lsl.w	#1,d3
; 		moveq	#%100,d3
		
		cmp.w	d1,d0
		blt.s	@NoFloorL_L
		swap	d1
		cmp.w	d1,d0
		bgt.s	@NoFloorL_R
		or.w	d3,d5
@NoFloorL_R:
		swap	d1
@NoFloorL_L:

@No_Floor:
		rts
		
; ----------------------------------
; Move level camera
; ----------------------------------

@plyr_camera:
		lea	(RAM_LevelBuffer),a5
		move.b	lvl_settings(a5),d0
		and.w	#$F,d0
		add.w	d0,d0
		move.w	@ScrollTypes(pc,d0.w),d1
		jmp	@ScrollTypes(pc,d1.w)
		
; -----------------------------------

@ScrollTypes:
		dc.w @Scrl_Normal-@ScrollTypes
		dc.w @Scrl_Section-@Scrolltypes
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
		dc.w 0
	
; -----------------------------------
; Default scroll
; 
; Autochecks the level size
; -----------------------------------

@Scrl_Normal:
		move.w	#320,d4
		btst	#bit_hortype,lvl_prio(a5)
		beq.s	@normal_hor
		move.w	#256,d4
@normal_hor:
		move.w	d4,d0
		lsr.w	#4,d0
		move.w	lvl_x_size(a5),d1
		cmp.w	d0,d1
		ble.s	@DontScrollHor
		
		move.w	obj_x(a6),d3
		moveq	#0,d2
		move.w	d4,d1
		lsr.w	#1,d1
		sub.w	d1,d3
		bmi.s	@Wait_X
		move.w	d3,d2
		
		moveq	#bit_drw_r,d0
 		bset	d0,lvl_drawdir(a5)
; 		btst	#bitobj_dir,obj_status(a6)
; 		beq.s	@RightDir
		moveq	#bit_drw_l,d0
; @RightDir:
 		bset	d0,lvl_drawdir(a5)
@Wait_X:
		move.w	lvl_x_size(a5),d1
		move.w	d4,d0
		lsr.w	#4,d0
		sub.w	d0,d1
		move.w	d2,d0
		sub.w	#1,d0
		lsl.w	#4,d1
		cmp.w	d1,d0
		blt.s	@NotEnd_X
		move.w	d1,d2
@NotEnd_X:
		move.w	d2,d0
		lsr.w	#4,d0
		move.w	d2,lvl_x(a5)

@DontScrollHor:

; ------------------------
; Update Vertical
; scrolling
; ------------------------
	
 		cmp.w	#(224/16),lvl_y_size(a5)
 		ble.s	@DontScrollVer
		move.w	obj_y(a6),d3
		moveq	#0,d2
		sub.w	#((224/2)+$18),d3
		bmi.s	@Wait_Y
		move.w	d3,d2
@Wait_Y:
 		move.w	lvl_y_size(a5),d1
 		sub.w	#(224/16),d1
 		move.w	d2,d0
 		sub.w	#1,d0
 		lsl.w	#4,d1
 		cmp.w	d1,d0
 		blt.s	@NotEnd_Y
 		move.w	d1,d2
@NotEnd_Y:
 		move.w	lvl_y(a5),d0
 		cmp.w	d2,d0
 		beq.s	@low_y
 		
   		tst.l	obj_y_spd(a6)
  		beq.s	@low_y
		moveq	#0,d0
		moveq	#bit_drw_d,d0
		move.w	lvl_y(a5),d1
 		cmp.w	d1,d2
 		bge.s	@down_dir
 		moveq	#bit_drw_u,d0
@down_dir:
     		bset	d0,lvl_drawdir(a5)
@low_y:
		move.w	d2,lvl_y(a5)
 		
@DontScrollVer:
		rts
		
; -----------------------------------
; Dungeon Scroll
; -----------------------------------

@Scrl_Section:
		btst	#bitobj_dir,obj_status(a6)
		bne.s	@LeftCheck
		
; RIGHT

 		btst	#0,plyr_busy(a6)
 		bne.s	@MoveRight
 		
		move.w	obj_x(a6),d1
		move.w	#320,d0
		move.w	d0,d2
		add.w	lvl_x(a5),d2
		move.w	d2,plyr_lvltrgt(a6)
		add.w	#8,d0
 		add.w	lvl_x(a5),d0
 		cmp.w	d0,d1
		blt.s	@UpDownChk
 		
 		bset	#0,plyr_busy(a6)
 		clr.l	obj_x_spd(a6)
 		clr.l	obj_y_spd(a6)

@MoveRight:
  		move.w	lvl_x(a5),d1
 		lea	(RAM_HorBuffer),a4
 		move.w	#224-1,d3
@doline2:
 		move.w	d1,d0
 		neg.w	d0
 		move.w	d0,(a4)+
 		asr.w	#4,d0
 		move.w	d0,(a4)+
 		dbf	d3,@doline2
 		
  		move.w	plyr_lvltrgt(a6),d0
  		move.w	lvl_x(a5),d1
  		cmp.w 	d0,d1
  		bcs.s	@KeepScrlR
 		bclr	#0,plyr_busy(a6)
  		move.w	d1,lvl_x(a5)
		rts
@KeepScrlR:
 		add.w	#4,lvl_x(a5)
      		bset	#bit_drw_r,lvl_drawdir(a5)
       		rts
		
@LeftCheck:
       		
		
@UpDownChk:
 		bclr	#0,plyr_busy(a6)
		rts
		
; =================================================================
; 
Plyr_SetStartPos:
  		lea	(RAM_ObjBuffer),a6
 		lea	(RAM_LevelBuffer),a5
 		
 		move.w	d0,obj_y(a6)
 		swap	d0
 		move.w	d0,obj_x(a6)
 		
; ----------------------------------------
 
 		clr.w	lvl_x(a5)
 		move.w	obj_x(a6),d0
 		cmp.w	#(320/2),d0
 		blt	@Normal
 		sub.w	#(320/2),d0
 		move.w	d0,lvl_x(a5)
 
@Normal:
 		move.w	#$A0,d1
 ; 		btst	#bitDouble,LvlProp(a5)
 ; 		beq.s	@Normal2
 ; 		move.w	#$50,d1
 ; @Normal2:
 		clr.w	lvl_y(a5)
 		move.w	obj_y(a6),d0
 		cmp.w	d1,d0
 		blt	@NormalY_3
 		sub.w	d1,d0
 		move.w	d0,lvl_y(a5)
 
 		move.w	lvl_y_size(a5),d1
 		move.w	#$D,d2
 ; 		btst	#bitDouble,LvlProp(a5)
 ; 		beq.s	@NormalY_2
 ; 		move.w	#6,d2
 ; @NormalY_2:
 		sub.w	d2,d1
 		lsl.w	#4,d1
 		cmp.w	d1,d0
 		blt.s	@NormalY_3
 		move.w	d1,lvl_y(a5)
 
@NormalY_3:	
   		bsr	Level_Draw
 		
@Return:
 		rts
		
; =================================================================
; ------------------------------------------------
; Data
; ------------------------------------------------
		
Ani_Player:
		dc.w @Idle-Ani_Player
		dc.w @Walk-Ani_Player
		dc.w @Jump_1-Ani_Player
		dc.w @Jump_2-Ani_Player
		even
@Idle:
 		dc.b 5
 		dc.b 0
		dc.b $FF
		even
@Jump_1:	
 		dc.b 4
 		dc.b 7
		dc.b $FF
		even
@Jump_2:	
 		dc.b 4
 		dc.b 8
		dc.b $FF
		even
@Walk:
 		dc.b 3
 		dc.b 1,2,3,4,5,6
		dc.b $FF
		even
		