; =================================================================
; Title
; =================================================================

; =================================================================
; ------------------------------------------------
; Includes
; ------------------------------------------------

; =================================================================
; ------------------------------------------------
; Variables
; ------------------------------------------------

; =================================================================
; ------------------------------------------------
; RAM (for RAM_ModeBuffer)
; ------------------------------------------------

		rsreset
TanValue	rs.w	1
SpeedVal	rs.w	1
StrchVal	rs.w	1
WaveVal		rs.w	1
Timer1		rs.w	1
TmpVal_Rot	rs.w	1
TmpVal_Zoom	rs.w	1
PickSong	rs.w	1
PickLevel	rs.w	1
StrchVer	rs.w	1

StampX		rs.w	1
StampY		rs.w	1
StampXD		rs.w	1
StampYD		rs.w	1
StampRot	rs.w	1
ModelZ		rs.w	1
FrmBuff		rs.w	1

; =================================================================
; ------------------------------------------------
; Init
; ------------------------------------------------

mode_Title:
		bsr	Mode_FadeOut

		move.w	#$2700,sr
		
; -----------------------------------
; Cleanup
; -----------------------------------

		bsr	Vdp_ClearPlanes
		bsr	Mode_Cleanup
		
		move.l	#VInt_Default,(RAM_VIntAddr)
		move.l	#Hint_Default,(RAM_HIntAddr)
		lea	(RAM_VdpRegs),a0
    		move.b	#0,vdpReg_HVal(a0)
		move.b	#vdp_H40,vdpReg_HMode(a0)
		move.b	#1,vdpReg_PlnSize(a0)
		move.b	#3,vdpReg_Scroll(a0)
		clr.b	vdpReg_WindowY(a0)
 		bsr	Vdp_Update

; -----------------------------------
; MARS ONLY: init 3D object
; -----------------------------------

   		if MARS
		bset	#FM,(marsreg+access)
		
		moveq	#1,d1
		moveq	#$E,d0
		bsr	Mars_DoTask_Master
		
 		move.l	#mars_pal_title,d1
 		move.l	#$000000FF,d2
 		moveq	#3,d0
 		bsr	Mars_DoTask_Master
;   		move.l	#mars_art_title,d1
;   		move.l	#0,d2
;   		move.l	#((320)<<16)|224,d3
;   		moveq	#1,d0
;   		bsr	Mars_DoTask_Master
; 		moveq	#$F,d0
; 		bsr	Mars_DoTask_Master

 		move.l	#test_model,d1
  		moveq	#0,d2
  		moveq	#$20,d0
   		bsr	Mars_DoTask_Master

      		move.w	#1,(marsreg+comm4)
   		moveq	#$10,d0
  		bsr	Mars_Task_Master
  		bsr	Mars_Wait_Master
		bsr	MARS_ModelInit
		
; -----------------------------------
; CD ONLY: init stamps
; -----------------------------------

		elseif SegaCD
		
  		lea	(RAM_PalFadeBuff),a1
		lea	(Pal_StampsTest),a0
  		move.w	#$F,d0
  		bsr	LoadData_Word
  		
		move.l	#$40000003,d0
		move.w	#$0001,d1
		bsr	Stamps_AutoMap
		
  		lea	(RAM_VdpRegs),a0
		move.b	#vdp_H32,vdpReg_HMode(a0)
		bsr	Vdp_Update
		
 		bset	#1,(ThisCpu+MemoryMode+1)		; WordRAM -> SubCPU
		moveq	#$30,d0
		bsr	SubCpu_Task_Wait
 		moveq	#CD_WordRamToMain,d0			; WordRAM -> MainCPU
 		bsr	SubCpu_Task_Wait
 		
; -----------------------------------
; Show sample picture
; -----------------------------------

		else
		
 		lea	(Map_Title),a0
 		moveq	#1,d0
 		move.l	#($0000<<16)|$0000,d1
  		move.l	#((((320)/8)-1)<<16)|(((224)/8)-1),d2
 		move.w	#1,d3
 		bsr	VDP_LoadMaps
		lea	(Art_Title),a0
		move.w	#1,d0
		move.w	(a0)+,d1
		bsr	VDP_SendData_L
  		lea	(RAM_PalFadeBuff),a1
		lea	(Pal_Title),a0
  		move.w	#$F,d0
  		bsr	LoadData_Word

   		lea	(Art_DebugFont),a0
   		move.w	#$580,d0
   		move.w	#((Art_DebugFont_End-Art_DebugFont)/4)-1,d1
   		bsr	VDP_SendData_L

   		endif
   		
; -----------------------------------

		move.w	#$2000,sr
 		bsr	Mode_FadeIn
		
; =================================================================
; ------------------------------------------------
; Loop
; ------------------------------------------------

Title_Loop:
		bsr	VSync
	
		if MARS
		lea	(RAM_ModeBuffer),a1
		bsr	MarsMdl_Control
		elseif SegaCD
		lea	(RAM_ModeBuffer),a1
		bsr	Stamp_Control
		endif
		
		btst	#bitJoyStart,(RAM_Joypads+OnPress)
		beq.s	@NotStart
		bra	Title_LoadLevel
@NotStart:
		bra	Title_Loop
                
; =================================================================
; ------------------------------------------------
; Hblank
; ------------------------------------------------
	
HInt_Title:
		rts
		
; =================================================================
; ------------------------------------------------
; VBlank
; ------------------------------------------------

Vint_Title:
		rts
		
; =================================================================
; ------------------------------------------------
; Subs
; ------------------------------------------------
		
; ---------------------------
; Load level
; ---------------------------

Title_LoadLevel:
		move.w	#0,(RAM_SharedBuffer)
		
		if MARS
		
		endif
		
		bsr	Mode_FadeOut
 		move.b	#1,(RAM_GameMode)
		rts
		
; -------------------

Stamps_AutoMap:
		moveq	#$1F,d2
@NextLine:
		move.l	d0,d4
		move.w	d1,d5
		move.w	#((256*224)>>$B)-1,d3
@Next:
		move.l	d4,($C00004).l
		move.w	d5,($C00000).l
		add.l	#$800000,d4
		add.w	#$0001,d5
		dbf	d3,@Next
		
		add.w	#((256*224)>>$B),d1
		add.l	#$20000,d0
		dbf	d2,@NextLine
		rts
		
		
Stamp_Control:
		if SegaCD
   		
; ------------------------------------------
; SEGA CD controls
; ------------------------------------------

    		btst	#bitJoyLeft,(RAM_Joypads+OnHold)
    		beq.s	@dontscrl_left
		sub.w 	#1,StampX(a1)
@dontscrl_left:
  		btst	#bitJoyRight,(RAM_Joypads+OnHold)
  		beq.s	@dontscrl_right
		add.w 	#1,StampX(a1)
@dontscrl_right:
   		btst	#bitJoyDown,(RAM_Joypads+OnHold)
   		beq.s	@dontscrl_down
		add.w 	#1,StampY(a1)
@dontscrl_down:
		btst	#bitJoyUp,(RAM_Joypads+OnHold)
		beq.s	@dontscrl_up
		sub.w 	#1,StampY(a1)
@dontscrl_up:

    		btst	#bitJoyX,(RAM_Joypads+ExOnHold)
    		beq.s	@dontscrl_X
		add.w 	#1,StampXD(a1)
@dontscrl_X:
    		btst	#bitJoyZ,(RAM_Joypads+ExOnHold)
    		beq.s	@dontscrl_y
		add.w 	#1,StampYD(a1)
@dontscrl_y:
    		btst	#bitJoyY,(RAM_Joypads+ExOnHold)
    		beq.s	@dontscrl_z
		sub.w 	#1,StampXD(a1)
@dontscrl_z:
    		btst	#bitJoyMode,(RAM_Joypads+ExOnHold)
    		beq.s	@dontscrl_m
		sub.w 	#1,StampYD(a1)
@dontscrl_m:


    		btst	#bitJoyLeft,(RAM_Joypads+Port2+OnHold)
    		beq.s	@dontscrl_rz
		sub.w 	#1,StampRot(a1)
; 		add.w 	#1,(RAM_HorBuffer+2)
@dontscrl_rz:
    		btst	#bitJoyRight,(RAM_Joypads+Port2+OnHold)
    		beq.s	@dontscrl_rm
		add.w 	#1,StampRot(a1)
; 		sub.w 	#1,(RAM_HorBuffer+2)
@dontscrl_rm:

; 		bsr	ShowStamps
		
; ---------------------------
; SEGA CD: transfer stamp
; data
; ---------------------------

ShowStamps:
		lea	(ThisCpu+CommDataM),a0
		move.w	#0,(a0)+
		move.w	StampX(a1),d0
		move.w	d0,(a0)+
		move.w	StampY(a1),d0
		move.w	d0,(a0)+
		move.w	StampXD(a1),d0
		move.w	d0,(a0)+
		move.w	StampYD(a1),d0
		move.w	d0,(a0)+
		move.w	StampRot(a1),d0
		move.w	d0,(a0)+
		moveq	#$34,d0
		bsr	SubCpu_Task_Wait
		
; 		lea	(ThisCpu+CommDataM),a0
; 		move.w	#0,(a0)
; 		move.w	StampX(a1),d0
; 		move.w	d0,(a0)+
; 		move.w	StampY(a1),d0
; 		move.w	d0,(a0)+
; 		move.w	#0,(a0)+
; 		move.w	#0,(a0)+
; 		move.w	StampYD(a1),d0
; 		move.w	d0,(a0)+
; 		moveq	#$34,d0
; 		bsr	SubCpu_Task_Wait
		
		moveq	#$38,d0
		bsr	SubCpu_Task_Wait

		move.w	#$100,($A11100).l
@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80
		
 		move.l	#$40200000,d0
;  		tst.w	(RAM_ModeBuffer+FrmBuff)
;  		beq.s	@firstfrm
;  		move.l	#$68200001,d0
; @firstfrm:
; 
 		move.l	#$200000+$38E00,d1
 		move.w	#((256*224)>>2),d2
 		bsr	DMA_QuickSet
 		
		move.w	#0,($A11100).l
		
; 		bchg	#0,(RAM_ModeBuffer+FrmBuff)
		endif
		rts
		

; ---------------------------
; MARS model control
; ---------------------------

MarsMdl_Control:
		if MARS
		
		;UPLR: X / Y
    		btst	#bitJoyLeft,(RAM_Joypads+OnHold)
    		beq.s	@dontscrl_left
		sub.w 	#1,StampX(a1)
@dontscrl_left:
  		btst	#bitJoyRight,(RAM_Joypads+OnHold)
  		beq.s	@dontscrl_right
		add.w 	#1,StampX(a1)
@dontscrl_right:
   		btst	#bitJoyDown,(RAM_Joypads+OnHold)
   		beq.s	@dontscrl_down
		add.w 	#1,StampY(a1)
@dontscrl_down:
		btst	#bitJoyUp,(RAM_Joypads+OnHold)
		beq.s	@dontscrl_up
		sub.w 	#1,StampY(a1)
@dontscrl_up:

		; BC: Z
   		btst	#bitJoyB,(RAM_Joypads+OnHold)
   		beq.s	@dontscrl_zdown
		add.w 	#2,ModelZ(a1)
@dontscrl_zdown:
		btst	#bitJoyA,(RAM_Joypads+OnHold)
		beq.s	@dontscrl_zup
		sub.w 	#2,ModelZ(a1)
@dontscrl_zup:

		;ROTATE
    		btst	#bitJoyC,(RAM_Joypads+OnHold)
    		beq.s	@dontscrl_rotxdown
 		add.w 	#4,StampXD(a1)
@dontscrl_rotxdown:
 		btst	#bitJoyZ,(RAM_Joypads+ExOnHold)
 		beq.s	@dontscrl_rotxup
 		sub.w 	#4,StampXD(a1)
@dontscrl_rotxup:	
 		
    		btst	#bitJoyY,(RAM_Joypads+ExOnHold)
    		beq.s	@dontscrl_rotydown
 		add.w 	#4,StampYD(a1)
@dontscrl_rotydown:
 		btst	#bitJoyX,(RAM_Joypads+ExOnHold)
 		beq.s	@dontscrl_rotyup
 		sub.w 	#4,StampYD(a1)
@dontscrl_rotyup:

; ------------------------------------------------

 		bsr	Mars_Wait_Master_Flag
 		bne.s	Mars_RenderReturn
 		
MARS_ModelInit:
  		move.w	#0,(marsreg+comm4)
  		move.w	StampXD(a1),(marsreg+comm6)
  		move.w	StampYD(a1),(marsreg+comm8)
  		move.w	#0,(marsreg+comm10)
  		moveq	#$23,d0
  		bsr	Mars_Task_Master
  		bsr	Mars_Wait_Master
 		
      		move.w	#0,(marsreg+comm4)
      		move.w	StampX(a1),(marsreg+comm6)		;d1	X
      		move.w	StampY(a1),(marsreg+comm8)		;	Y
        	move.w	ModelZ(a1),(marsreg+comm10) 		;d0	Z
      		moveq	#$22,d0
      		bsr	Mars_Task_Master
      		bsr	Mars_Wait_Master			
 		
Mars_RenderReturn:

; -----------------------------------
      		
 		endif
		rts
		
; =================================================================
; ------------------------------------------------
; Data
; ------------------------------------------------
		