; ====================================================================

		include	"engine/ram.asm"
		include	"mars/incl/68k_map.asm"
		
; ====================================================================
; ---------------------------------------------
; Header / Init
; ---------------------------------------------

		include "mars/init.asm"
		
; ====================================================================
; ---------------------------------------------
; IPL
; ---------------------------------------------

		include	"engine/main.asm"

; -------------------------------------------------
; Mode list
; -------------------------------------------------

GameModes:
 		dc.l mode_Title
 		dc.l mode_Level
 		even

; ====================================================================
; ---------------------------------------------
; MARS subs
; ---------------------------------------------

		include	"mars/subs.asm"
		
; ====================================================================
; ---------------------------------------------
; Subs
; ---------------------------------------------

		include	"engine/subs/vdp.asm"
		include	"engine/subs/fade.asm"
		include	"engine/subs/misc.asm"
		include	"engine/subs/pads.asm"
		include	"engine/subs/dma.asm"
                include	"engine/ints.asm"
                
; ====================================================================
; ---------------------------------------------
; Code | Modes
; ---------------------------------------------

		include	"engine/modes/level/code.asm"
		include	"engine/modes/title/code.asm"
		
; ---------------------------------------------
; Code | Sound
; ---------------------------------------------

		include	"engine/sound/code.asm"
	
; ====================================================================

  		objend
		inform 0,"*** MARS 68k IPL SIZE:  %h of 7FFFF ***",*	;MAX: $7FFFF
   		obj *+marsbank
   		
; ====================================================================
; ---------------------------------------------
; Data | Shared
; ---------------------------------------------

		include	"engine/shared/main.asm"
		
; ---------------------------------------------
; Data | Modes
; ---------------------------------------------

		include	"engine/modes/level/data/main.asm"
		include	"engine/modes/title/data/main.asm"
		
; ---------------------------------------------
; Data | Sound
; ---------------------------------------------

		include	"engine/sound/data/main.asm"

; ====================================================================

  		objend					;End of marsbank
		inform 0,"*** MARS 68k DATA SIZE: %h of FFFFF ***",*
		cnop 0,$8000
		
; ====================================================================
; ---------------------------------------------
; SH2
; ---------------------------------------------

SH2_Start:
		incbin	"mars/sh2/code.bin"
SH2_End:
		cnop 0,4
		
; ====================================================================
; ---------------------------------------------
; ROM data aligned for SH2
; ---------------------------------------------

Mars_Bank_1:
		obj *+$02000000
		
; ---------------------------------------------
; MARS Shared data
; ---------------------------------------------

		include	"engine/shared/mars.asm"

; ---------------------------------------------
; MARS Sound
; ---------------------------------------------

 		include	"engine/sound/data/mars.asm"

; ====================================================================

		objend			
  		inform 0,"MARS SH2 DATA SIZE: %h",(*-Mars_Bank_1)

; ====================================================================

 		inform 0,"ROM SIZE: %h",*
		cnop 0,$40000
MD_RomEnd:
		END
