#======================================================================
# TGA to SEGA VDP
# 
# STABLE
#======================================================================

#======================================================================
# -------------------------------------------------
# Subs
# -------------------------------------------------
    
def get_val(string_in):
  got_this_str=""
  for do_loop_for in string_in:
    got_this_str = got_this_str + ("0"+((hex(ord(do_loop_for)))[2:]))[-2:]
  return(got_this_str)

# -----------------------------

def read_byte(this_file):
  d7 = int(get_val(this_file.read(1)),16)
  return(d7)
  
def read_lword(this_file):
  d5 = read_byte(input_file) & 0xFF
  d6 = (read_byte(input_file) & 0xFF) << 8
  d7 = d5|d6
  return(d7)

# -----------------------------
# MEGA DRIVE
# -----------------------------

def cell_line_md(in_offset):
  input_file.seek(in_offset)
  
  a = read_byte(input_file)
  b = read_byte(input_file)
  c = read_byte(input_file)
  d = read_byte(input_file)
  e = read_byte(input_file)
  f = read_byte(input_file)
  g = read_byte(input_file)
  h = read_byte(input_file)
      
  a = a << 4
  a = a+b
  c = c << 4
  c = c+d
  e = e << 4
  e = e+f
  g = g << 4
  g = g+h

  out_art.write(chr(a))
  out_art.write(chr(c))
  out_art.write(chr(e))
  out_art.write(chr(g))

# -----------------------------
# CELLS
# -----------------------------

def seek_cell(x,y):
  x = x<<3
  y = y*(x_size*8)
  
  d7=x+y
  return(d7)

# -----------------------------

def write_cell(cell_off):
  rept = 8
  while rept:
    cell_line_md(cell_off)
    cell_off += x_size
    rept -= 1

# -----------------------------

def chks_make(lay):
  d7 = 0
  
  d4 = 0
  d5 = 0
  d1 = 8
  while d1:
    input_file.seek(lay)
    d2 = 8
    while d2:
      byte = read_byte(input_file)
      if byte != 0:
	d7 += (byte&0x0F) + d4 + d5

      d4 += 1
      d2 -= 1
    lay += x_size
    d5 += 1
    d1 -= 1

  return(d7)

# -----------------------------

def find_rept(chksum):
  sizeof_filter=2				#number of list entries
  
  d1 = 0
  a0=checksum
  result=False
  d0 = len(a0)
  if d0 != 0:
    while d0:
      d0 -= sizeof_filter
      if a0[d1] == chksum:
	result=True
	d1= a0[d1+1]
	d0 = False
      d1 += sizeof_filter

  return(result,d1)

#======================================================================
# -------------------------------------------------
# Settings
# -------------------------------------------------

VRAM_BLANK = 0
VRAM_START = 1

#======================================================================
# -------------------------------------------------
# Init
# -------------------------------------------------

used_cells = 0
pal_type   = False
img_type   = False
checksum   = list()

pal_size   = 0
x_size     = 0
y_size     = 0

#======================================================================
# -------------------------------------------------
# Start
# -------------------------------------------------

d0 = raw_input("TGA File? ")
if d0 == "":
  d0 = "in.tga"
input_file=open(d0,"rb")

input_file.seek(0x1)					#COLOR Type (none/ pallete included)
pal_type = read_byte(input_file)
img_type = read_byte(input_file)

# *****************************
# INDEXED TGA
# *****************************

if img_type == 1:
  #print "*** TGA file is indexed ***"
  
  d0 = raw_input("Palette filename: ")
  if d0 == "":
    d0 = "pal.bin"
  out_pal=open(d0,"wb")
    
  d0 = raw_input("Graphics filename: ")
  if d0 == "":
    d0 = "art.bin"
  out_art=open(d0,"wb")

  d0 = raw_input("Mappings filename: ")
  if d0 == "":
    d0 = "map.bin"
  out_map=open(d0,"wb")

  # -----------------------------
  # Color data
  # -----------------------------

  input_file.seek(0x5)		#Color size
  pal_size = read_lword(input_file)
  input_file.seek(0x12)		#Color data
  d0 = pal_size
  while d0:
    b = read_byte(input_file)
    g = read_byte(input_file)
    r = read_byte(input_file)
    
    r = r >> 5
    r = r << 1
    g = g >> 5
    g = g << 1
    b = b >> 5
    b = b << 1
    g = g << 4
    gr = g+r
    out_pal.write(chr(b))
    out_pal.write(chr(gr))

  #print hex(r),hex(g),hex(b)
    d0 -= 1
  out_pal.close()
  #print "*** Palette done."
    
# -----------------------------
# Cell/Maps
# -----------------------------

  input_file.seek(0xC)  
  x_size = read_lword(input_file)
  y_size = read_lword(input_file)
  print "X:",x_size,"Y:",y_size
    
  # -----------------------------
  # With mappings
  # -----------------------------
  
  
  #if INCL_BLANK == True:
    ##TODO: also ask for the byte ($0-$F)
    #out_art.write(chr(INCLBLNKID&0x0F)*0x20)
    #print "*** Wrote blank cell"
  
  # VRAM start address
  vram = VRAM_START
  
  #From here, then the indexed data
  input_file.seek(0x12)
  input_file.seek((pal_size*3),True)
  image_addr=input_file.tell()
  
  y_pos=0
  cell_y_size=(y_size>>3)
  while cell_y_size:
    x_pos=0
    cell_x_size=(x_size>>3)
    while cell_x_size:
      d1 = VRAM_BLANK
      d2 = image_addr+seek_cell(x_pos,y_pos)
      d3 = chks_make(d2)
      if d3 != 0:
	if find_rept(d3)[0] == True:
	  d1=find_rept(d3)[1]
	else:
	  write_cell(d2)
	  used_cells += 1
	  d1=vram
	  checksum.append(d3)
	  checksum.append(d1)
	  vram+=1

      out_map.write(chr(int((d1&0xFF00)>>8)&0xFF)+chr(int(d1)&0xFF))
      x_pos+=1
      cell_x_size -= 1
    y_pos+=1
    cell_y_size -= 1
    
  print "Cells used:",hex(used_cells)
  print "*** Done."
  
  #print checksum
  input_file.close()
  out_art.close()

# *****************************
# RGB TGA
# *****************************

if img_type == 2:
  print "*** TGA file is RGB ***"
  print "nothing to do."

#======================================================================


