; =====================================================================
; WORD-RAM Program
;
; Level mode
; =====================================================================

; ---------------------------------------------
; Variables
; ---------------------------------------------

ThisCpu		equ $A12000
CD_PrgRamMode	= 0

; =====================================================================
; ---------------------------------------------
; Custom header
; ---------------------------------------------
		
; =====================================================================
; ---------------------------------------------
; Include
; ---------------------------------------------

		include "engine/ram.asm"
		include	"cd/incl/equs.asm"
		org $200000

; =====================================================================
; ---------------------------------------------
; Init
; ---------------------------------------------

PrgCode:
		move.w	#$2700,sr
		
		move.w	#$4EF9,(RAM_GoToHint)
		move.l	#MD_Hint,(RAM_GoToHint+2)
		move.w	#((RAM_GoToHint)&$FFFF),($A12006).l
 		move.l	#MD_Hint,($FFFFFD0E)
  		move.l	#MD_Vint,($FFFFFD08)
		
; ====================================================================
; -------------------------------------------------
; Program data
; -------------------------------------------------
		
		move.l	#VInt_Default,(RAM_VIntAddr)
		move.l	#Hint_Default,(RAM_HIntAddr)
		clr.b	(RAM_VIntWait)
		clr.l	(RAM_DMA_Buffer)
		
		bsr	Vdp_Init
		bsr	Pads_Init
		bsr	SMEG_Init
		
		move.w	#$2000,sr
		
; -------------------------------------------------
; Modes
; -------------------------------------------------

@RunMode:
                moveq	#0,d0
                move.b	(RAM_GameMode),d0
                add.w	d0,d0
                add.w	d0,d0       
                lea	GameModes(pc),a0
                movea.l	(a0,d0.w),a0
                jsr	(a0)
                bra.s	@RunMode
		
; -------------------------------------------------
; Mode list
; -------------------------------------------------

GameModes:
 		dc.l mode_Title
;  		dc.l mode_Level
 		even

; ---------------------------------------------
; Subs
; ---------------------------------------------

		include	"engine/subs/vdp.asm"
		include	"engine/subs/fade.asm"
		include	"engine/subs/misc.asm"
		include	"engine/subs/joypads.asm"
		include	"engine/subs/dma.asm"
                include	"engine/ints.asm"
                include	"cd/incl/subtask.asm"
                
; ====================================================================
; ---------------------------------------------
; Code | Modes
; ---------------------------------------------

; 		include	"engine/modes/level/code.asm"
		include	"engine/modes/title/code.asm"
		
; ---------------------------------------------
; Code | Sound
; ---------------------------------------------

		include	"engine/sound/code.asm"
	
; ====================================================================

 		inform 0,"CODE ENDS: %h",(*-$200000)-1
 		
; ====================================================================

; ---------------------------------------------
; Data | Shared
; ---------------------------------------------

		include	"engine/shared/main.asm"
		
; ---------------------------------------------
; Data | Modes
; ---------------------------------------------

 		include	"engine/modes/level/data/main.asm"
		include	"engine/modes/title/data/main.asm"
		
; ---------------------------------------------
; Data | Sound
; ---------------------------------------------

		include	"engine/sound/data/main.asm"
		
; =====================================================================

@Here:
; 		if (@Here-$200000)-1 > $3FFFF:
; 		  inform 2,"(SEGA CD) RAN OUT OF WORD-RAM %h",(@Here-$200000)-1
; 		else
 		  inform 0,"*** This PRG Size: %h of 3FFFF ***",(@Here-$200000)-1
;  		endif
 		
		cnop 0,$40000
		