; ====================================================================
; ---------------------------------------------
; Subs
; ---------------------------------------------

		include	"engine/subs/vdp.asm"
		include	"engine/subs/misc.asm"
		include	"engine/subs/joypads.asm"
                include	"engine/ints.asm"

; ====================================================================
; -------------------------------------------------
; Start
; -------------------------------------------------

MD_Main:
		move.w	#$2700,sr
		
		move.l	#VInt_Default,(RAM_VIntAddr)
		move.l	#Hint_Default,(RAM_HIntAddr)
		bsr	VDP_Setup
		bsr	Pads_Init
 		bsr	Z80_Init
		
; -------------------------------------------------
; Init
; -------------------------------------------------

		move.l	#Sample_1,d0
		move.l	#Sample_1_End,d1
		move.l	#Sample_1,d2
		moveq	#1,d3
 		bsr	PlaySample
 		
		moveq	#$3C+12,d0		; NOTE
		move.w	d0,$FFFF0000
 		move.w	#$2000,sr
		
; -------------------------------------------------
; Loop
; -------------------------------------------------

@Loop:
		bsr	VSync

  		btst	#bitJoyUp,(RAM_Joypads+OnPress)
  		beq.s	@NotUp
  		
  		add.w	#1,$FFFF0000
		bsr	@ChangeIt
@NotUp:
  		btst	#bitJoydown,(RAM_Joypads+OnPress)
  		beq.s	@Notdown
  		
  		sub.w	#1,$FFFF0000
		bsr	@ChangeIt
@Notdown:

; 		move.l	#Sample_1,d0
; 		move.l	#Sample_1_End,d1
; 		move.l	#Sample_1,d2
; 		moveq	#0,d3
;  		bsr	PlaySample
; @NotDown:
;  		btst	#bitJoyB,(RAM_Joypads+OnHold)
;  		beq.s	@NotB
; 		move.w	#$100,($A11100).l
; @WaitZ802:
; 		btst	#0,($A11100).l
; 		bne.s	@WaitZ802
; 		move.b	#0,($A001E0+$D)
;  		move.w  #$0,($A11100)
; @NotB:
		
                bra.s	@Loop
          
@ChangeIt:
		move.w	#$100,($A11100).l
@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80
		
		moveq	#0,d0			; NOTE
		move.w	($FFFF0000),d0
 		sub.w	#12-1,d0
		move.w	d0,d1
		lsl.w	#6,d1
		add.w	#$200,d1
		move.b	d1,($A000F6)		; ld bc,(NEW ADDRESS)
		lsr.w	#8,d1			;
		move.b	d1,($A000F7)		;
		
 		move.w  #$0,($A11100)
		rts
		
; ====================================================================

Z80_Init:
		move.w	#$100,($A11100).l
		move.w	#$100,($A11200).l
@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80

		lea	Z80_Driver(pc),a0
		lea	($A00000).l,a1
		move.w	#(Z80_Driver_End-Z80_Driver)-1,d1
@ToZ80:
		move.b	(a0)+,(a1)+
		dbf	d1,@ToZ80
    
; -----------------------------------

 		move.w	#0,($A11200).l
		nop
		nop
		nop
		nop
 		move.w	#$100,($A11200).l
 		move.w	#0,($A11100).l
		rts
    
; ====================================================================

; d0 - Start
; d1 - Loop
; d2 - End

PlaySample:
		move.w	#$100,($A11100).l
@WaitZ80:
		btst	#0,($A11100).l
		bne.s	@WaitZ80

		lea	($A001E0),a0
		;Start
		moveq	#0,d4
		tst.w	d0
		bpl.s	@plus_s
		move.w	#$81,d4
@plus_s:
		swap	d0
		swap	d4
		move.b	d0,d4
		swap	d4
		swap	d0
		move.b	d4,(a0)+		;start Bank	+$8000
		swap	d4
		move.b	d4,(a0)+		;		$xx0000
		swap	d4
		move.b	d0,(a0)+		;start Addr	$00xx
		lsr.w	#8,d0
		move.b	d0,(a0)+		;		$xx00
		
		;Loop
		moveq	#0,d4
		tst.w	d1
		bpl.s	@plus_e
		move.w	#$81,d4
@plus_e:
		swap	d1
		swap	d4
		move.b	d1,d4
		swap	d4
		swap	d1
		move.b	d4,(a0)+		;start Bank	+$8000
		swap	d4
		move.b	d4,(a0)+		;		$xx0000
		swap	d4
		move.b	d1,(a0)+		;start Addr	$00xx
		lsr.w	#8,d1
		move.b	d1,(a0)+		;		$xx00
		
		;End
		moveq	#0,d4
		tst.w	d2
		bpl.s	@plus_l
		move.w	#$81,d4
@plus_l:
		swap	d2
		swap	d4
		move.b	d2,d4
		swap	d4
		swap	d2
		move.b	d4,(a0)+		;start Bank	+$8000
		swap	d4
		move.b	d4,(a0)+		;		$xx0000
		swap	d4
		move.b	d2,(a0)+		;start Addr	$00xx
		lsr.w	#8,d2
		move.b	d2,(a0)+		;		$xx00
		
		moveq	#$3C+12,d0		; NOTE
  		sub.w	#12-1,d0
		move.w	d0,d1
		lsl.w	#6,d1
		add.w	#$200,d1
		move.b	d1,($A000F6)		; ld bc,(NEW ADDRESS)
		lsr.w	#8,d1			;
		move.b	d1,($A000F7)		;
		
		moveq	#1,d0			; TODO: Loop flag
		lsl.b	#1,d0
		bset	#0,d0
		move.b	d0,($A001E0+$D)
		
 		move.w  #$0,($A11100)
		rts
    
; ====================================================================

Z80_Driver:	incbin	"engine/sound/z80/main.bin"
Z80_Driver_End:
		even
		
		cnop 0,$4000
Sample_1:	incbin	"engine/sound/z80/test.wav",$2C,0x1F0000
Sample_1_End:
		even