; ===========================================================================
; Error screen
; ===========================================================================

MD_BusError:
		bsr	ErrorScr_Init
		lea	Asc_ErrBus(pc),a0
		bsr	ErrorScr_ShowMsg
		bra	ErrorScr_Loop

MD_AddrError:
		bsr	ErrorScr_Init
		lea	Asc_ErrAddr(pc),a0
		bsr	ErrorScr_ShowMsg
		bra.s	ErrorScr_Loop

MD_IllegalError:
		bsr	ErrorScr_Init
		lea	Asc_ErrIlle(pc),a0
		bsr	ErrorScr_ShowMsg
		bra.s	ErrorScr_Loop

MD_ZeroDivError:
		bsr	ErrorScr_Init
		lea	Asc_ErrZerDiv(pc),a0
		bsr	ErrorScr_ShowMsg
		bra.s	ErrorScr_Loop

MD_ChkError:
		bsr	ErrorScr_Init
		lea	Asc_ErrChk(pc),a0
		bsr	ErrorScr_ShowMsg
		bra.s	ErrorScr_Loop

MD_TrapVError:
		bsr	ErrorScr_Init
		lea	Asc_ErrTrapV(pc),a0
		bsr	ErrorScr_ShowMsg
		bra.s	ErrorScr_Loop

MD_PrivilegeError:
		bsr	ErrorScr_Init
		lea	Asc_ErrPriv(pc),a0
		bsr	ErrorScr_ShowMsg
		bra.s	ErrorScr_Loop

MD_TraceError:
		bsr	ErrorScr_Init
		lea	Asc_ErrTrace(pc),a0
		bsr	ErrorScr_ShowMsg
		bra.s	ErrorScr_Loop

MD_LineA_Error:
		bsr	ErrorScr_Init
		lea	Asc_ErrLineA(pc),a0
		bsr	ErrorScr_ShowMsg
		bra.s	ErrorScr_Loop

MD_LineF_Error:
		bsr	ErrorScr_Init
		lea	Asc_ErrLineF(pc),a0
		bsr	ErrorScr_ShowMsg

; ----------------------------------------------
; Loop
; ----------------------------------------------

ErrorScr_Loop:
		bsr	Pads_Read

		cmp.b	#JoyC,(RAM_Joypads+OnPress)
		beq.s	@View
		bra.s	ErrorScr_Loop


@View:
		move.w	#$8124,($C00004)
		move.w	#$8C00,($C00004)
		move.l	#$9000927C,($C00004)
		move.w	#$927C,($C00004)
		move.w	#$8164,($C00004)
		bchg	#0,($FFFFC000)
		beq.s	ErrorScr_Loop

		move.w	#$8124,($C00004)
		move.l	#$8C019081,($C00004)
		move.w	#$9200,($C00004)
		move.w	#$8164,($C00004)
		bra.s	ErrorScr_Loop

; ===========================================================================
; ----------------------------------------------
; Init
; ----------------------------------------------

ErrorScr_Init:
		move.w	#$8124,($C00004)
		move.w	#$8C00,($C00004)
		move.w	#$9000,($C00004)
		move.w	#$927C,($C00004)
		move.b	#$9F,($C00011).l
		move.b	#$BF,($C00011).l
		move.b	#$DF,($C00011).l
		move.b	#$FF,($C00011).l
		
		move.w	#$2700,sr

		movem.l	d0-d7/a0-a7,($FFFFC000)

		move.l	#$50000003,($C00004)
		move.w	#$37F,d0
@ClrWinScr:
		move.w	#$86C0,($C00000)
		dbf	d0,@ClrWinScr

		move.l	#$C0040000,($C00004).l
		move.w	#$0EEE,($C00000).l

		lea	Asc_ErrScr(pc),a0
		move.l	#$51860003,d1
		move.w	#$8660,d2
		moveq	#0,d3
		bsr	VDP_LoadAsc

		lea	Art_DebugFont(pc),a0
		move.w	#$680,d0
		move.w	#((Art_DebugFont_End-Art_DebugFont)/4)-1,d1
		bsr	VDP_SendData_L

		lea	($FFFFC000),a1
		move.l	#$518E0003,d3
		moveq	#7,d5
@ShowDdata:
		movem.l	d3,-(sp)
                moveq	#0,d0
                move.l	(a1),d0
                move.l	d3,d1
                move.w	#$8660+"0",d2
                bsr	VDP_ShowVal_Long
                movem.l	(sp)+,d3

                add.l	#$400000,d3
                adda	#4,a1
		dbf	d5,@ShowDdata

		lea	($FFFFC020),a1
		move.l	#$51A80003,d3
		moveq	#7,d5
@ShowAdata:
		movem.l	d3,-(sp)
                moveq	#0,d0
                move.l	(a1),d0
                move.l	d3,d1
                move.w	#$8660+"0",d2
                bsr	VDP_ShowVal_Long
                movem.l	(sp)+,d3

                add.l	#$400000,d3
                adda	#4,a1
		dbf	d5,@ShowAdata

		clr.b	($FFFFC000)

		move.w	#$8164,($C00004)
		rts

; ----------------------------------------------
; Show error text
; ----------------------------------------------

ErrorScr_ShowMsg:
		move.l	#$51060003,d1
		move.w	#$8660,d2
		moveq	#0,d3
		bra	VDP_LoadAsc

; ===========================================================================

Asc_ErrScr:
		dc.b "D0 $00000000 A0 $",$A
		dc.b "D1 $00000000 A1 $",$A
		dc.b "D2 $00000000 A2 $",$A
		dc.b "D3 $00000000 A3 $",$A
		dc.b "D4 $00000000 A4 $",$A
		dc.b "D5 $00000000 A5 $",$A
		dc.b "D6 $00000000 A6 $",$A
		dc.b "D7 $00000000 SP $",$A
		dc.b $A
		dc.b "(C) - SHOW LAST FRAME",$A
		dc.b "      (NO WINDOW)"
		dc.b 0
		even

Asc_ErrBus:	dc.b "BUS ERROR                ",0
		even
Asc_ErrAddr:	dc.b "ADDRESS ERROR            ",0
		even
Asc_ErrIlle:	dc.b "ILLEGAL INSTRUCTION      ",0
		even
Asc_ErrZerDiv:	dc.b "ZERO DIVIDE              ",0
		even
Asc_ErrChk:	dc.b "CHK INSTRUCTION          ",0
		even
Asc_ErrTrapV:	dc.b "TRAPV ERROR              ",0
		even
Asc_ErrPriv:	dc.b "PRIVILEGE ERROR          ",0
		even
Asc_ErrTrace:	dc.b "TRACE                    ",0
		even
Asc_ErrLineA:	dc.b "LINEA ERROR              ",0
		even
Asc_ErrLineF:	dc.b "LINEF ERROR              ",0
		even

Art_DebugFont:	incbin	"engine/misc/art_dbgfont.bin"
Art_DebugFont_End:
 		even
		